#property indicator_chart_window
#property indicator_buffers 0

#import "user32.dll"
  int PostMessageA(int hWnd,int Msg,int wParam,int lParam);
#import

#define WM_COMMAND 0x0111

#define LB_OFFSET -32
#define BEGIN_OFFSET 148

#define REFRESH_CODE 33324

double open, low, high, close;
int handle, PrevTime;
string SymbolName;

void GetSymbolName()
{
  SymbolName = StringSubstr(Symbol(), 3, 3) + StringSubstr(Symbol(), 0, 3);
  
  return;
}

bool GetBarPrices( int Pos )
{  
       double Open_EURUSD=iOpen("EURUSD",0,Pos);
       double Open_USDJPY=iOpen("USDJPY",0,Pos);
       double Open_GBPUSD=iOpen("GBPUSD",0,Pos);
       double Open_USDCAD=iOpen("USDCAD",0,Pos);
       double Open_USDCHF=iOpen("USDCHF",0,Pos);
      
       double High_EURUSD=iHigh("EURUSD",0,Pos);
       double High_USDJPY=iHigh("USDJPY",0,Pos);
       double High_GBPUSD=iHigh("GBPUSD",0,Pos);
       double High_USDCAD=iHigh("USDCAD",0,Pos);
       double High_USDCHF=iHigh("USDCHF",0,Pos);
       
       double Low_EURUSD=iLow("EURUSD",0,Pos);
       double Low_USDJPY=iLow("USDJPY",0,Pos);
       double Low_GBPUSD=iLow("GBPUSD",0,Pos);
       double Low_USDCAD=iLow("USDCAD",0,Pos);
       double Low_USDCHF=iLow("USDCHF",0,Pos);
       
       double Close_EURUSD=iClose("EURUSD",0,Pos);
       double Close_USDJPY=iClose("USDJPY",0,Pos);
       double Close_GBPUSD=iClose("GBPUSD",0,Pos);
       double Close_USDCAD=iClose("USDCAD",0,Pos);
       double Close_USDCHF=iClose("USDCHF",0,Pos);
      
      
      
  open  = 50.14348112 * MathPow(Open_EURUSD, -0.576) * MathPow(Open_USDJPY, 0.136) * MathPow(Open_GBPUSD, -0.119) * MathPow(Open_USDCAD, 0.091) *  MathPow(Open_USDCHF, 0.036);
  high  = 50.14348112 * MathPow(High_EURUSD, -0.576) * MathPow(High_USDJPY, 0.136) * MathPow(High_GBPUSD, -0.119) * MathPow(High_USDCAD, 0.091) *  MathPow(High_USDCHF, 0.036);
  low   = 50.14348112 * MathPow(Low_EURUSD, -0.576) * MathPow(Low_USDJPY, 0.136) * MathPow(Low_GBPUSD, -0.119) * MathPow(Low_USDCAD, 0.091) *  MathPow(Low_USDCHF, 0.036);
  close = 50.14348112 * MathPow(Close_EURUSD, -0.576) * MathPow(Close_USDJPY, 0.136) * MathPow(Close_GBPUSD, -0.119) * MathPow(Close_USDCAD, 0.091) *  MathPow(Close_USDCHF, 0.036);
  
  return;
}

void WriteBar( int STime, double SOpen, double SHigh, double SLow, double SClose, double SVolume )
{
  FileWriteInteger(handle, STime);
  FileWriteDouble(handle, SOpen);
  FileWriteDouble(handle, SLow);
  FileWriteDouble(handle, SHigh);
  FileWriteDouble(handle, SClose);
  FileWriteDouble(handle, SVolume);
  
  FileFlush(handle);
  
  return;
}

void WriteBars( int Pos )
{
  Pos--;
  
  while (Pos >= 0)
  {
    GetBarPrices(Pos);
    WriteBar(Time[Pos], open, high, low, close, Volume[Pos]);
    Pos--;  
  }
  
  return;
}

void ModifyLastBar( int Pos )
{
  GetBarPrices(Pos);
  
  FileSeek(handle, LB_OFFSET, SEEK_CUR);

  FileWriteDouble(handle, low);
  FileWriteDouble(handle, high);
  FileWriteDouble(handle, close);
  FileWriteDouble(handle, Volume[Pos]);
  
  FileFlush(handle);
  
  return;
}

void CreateHandle()
{
  string FileName;
  int Tmp[15], TmpTime;

  GetSymbolName();
  FileName = SymbolName + Period() + ".hst";
  handle = FileOpenHistory(FileName, FILE_BIN|FILE_WRITE);
  
  FileWriteInteger(handle, 400);
  FileWriteString(handle, "Created by " + WindowExpertName(), 64);
  FileWriteString(handle, SymbolName, 12);
  FileWriteInteger(handle, Period());
  FileWriteInteger(handle, Digits);
  FileWriteArray(handle, Tmp, 0, 15);
  
  return;
}

void RefreshChart()
{
  int hwnd = WindowHandle(SymbolName, Period());

  PostMessageA(hwnd, WM_COMMAND, REFRESH_CODE, 0);
    
  return;
}

void init()
{  
  CreateHandle();
  
  PrevTime = Time[0];

  return;
}

void deinit()
{
  FileClose(handle);
  
  return;
}

void start()
{
  static int PrevBars = 0;
  static int Pos;
  
  if (PrevTime != Time[0])
  {
    Pos = iBarShift(Symbol(), Period(), PrevTime);
    
    ModifyLastBar(Pos);
    WriteBars(Pos);
    
    PrevTime = Time[0];
    PrevBars = Bars;
  }
  else
  {
    if (PrevBars != Bars)
    {
      FileSeek(handle, BEGIN_OFFSET, SEEK_SET);
      
      WriteBars(Bars);
      
      PrevBars = Bars;
    }
    else
      ModifyLastBar(0);
  }

  RefreshChart();        

  return;
}